/*
 * Copyright (c) 2007 NTT DATA Corporation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package jp.terasoluna.rich.tutorial.service.validation;

import java.util.Calendar;
import java.util.Date;
import org.springframework.validation.Errors;
import jp.terasoluna.fw.util.DateUtil;
import jp.terasoluna.fw.validation.springmodules.BaseMultiFieldValidator;
import jp.terasoluna.rich.tutorial.service.bean.UserBean;


/**
 * 入力された年齢と、生年月日の相関入力チェックを行う。
 * 
 */
public class AgeValidator extends BaseMultiFieldValidator  {

    /**
     * 入力された年齢と、生年月日の相関入力チェックを行う。
     * 
     * @param obj 検査対象のJavaBean（UserBean）
     * @param errors エラー
     */
    @Override
    protected void validateMultiField(Object obj, Errors errors) {
        
        // キャスト可能かのチェック
        if (!(obj instanceof UserBean)) {
            errors.reject("error.common.00001");
            return;
        }
        
        // キャスト
        UserBean userBean = (UserBean) obj;
                        
        // 年齢と日付の取得
        int age = userBean.getAge();
        Date birth = userBean.getBirth();
        
        // 入力された年齢と、生年月日の相関入力チェック
        if (!validate(birth,age)){
            String[] replaceValues = {"age","birth"};
            errors.rejectValue("birth", 
                    "error.multiField", replaceValues, null);
        }

    }
    
    /**
     * 入力された年齢と、生年月日の相関入力チェックを行う。
     * 
     * @param birth 生年月日
     * @param age 年齢
     * @return チェック結果
     */
    private boolean validate(Date birth, int age) {
        // 生年月日＋年齢のCalendarを生成
        Calendar calendarBirth = Calendar.getInstance();
        calendarBirth.setTime(birth);
        calendarBirth.add(Calendar.YEAR,age);

        // 生年月日＋年齢＋１年のCalendarを生成
        Calendar calendarNextYear = Calendar.getInstance();
        calendarNextYear.setTime(birth);
        calendarNextYear.add(Calendar.YEAR,age+1);
    
        // 現在日付のCalendarを生成
        Calendar calendarSystemTime = Calendar.getInstance();
        calendarSystemTime.setTime(DateUtil.getSystemTime());
    
        if ( calendarBirth.before(calendarSystemTime)
                && calendarNextYear.after(calendarSystemTime) ){
            return true;
        } else {
            return false;
        }
    }

}
